
function createKillCountModData()
    local player = getSpecificPlayer(0);
    if player ~= nil and player:getModData().AKCModData == nil then
        player:getModData().AKCModData = {};
        local nbkill = player:getZombieKills();
        player:getModData().AKCModData.tk  = nbkill;
        player:getModData().AKCModData.gk  = nbkill;
        player:getModData().AKCModData.fk  = 0;
        player:getModData().AKCModData.ck  = 0;
    else
        if (player:getModData().AKCModData.ck == nil) then
            --backward compatibility for saves before v 1.2
            player:getModData().AKCModData.fk  = 0;
            player:getModData().AKCModData.ck  = player:getModData().AKCModData.tk-player:getModData().AKCModData.gk;
        end
    end
end

function removeFromTable(myTable, charStr)--coal and feathers for me
    local myNewTable = {}
    for key,value in pairs(myTable) do 
        if key ~= charStr then
            myNewTable[key] = value;--
        end
    end
    return myNewTable;
end

function updateKillCountB41_50_OnCharacterDeath(character)
    createKillCountModData();
    local charStr = tostring(character);
    local player = getSpecificPlayer(0);
    --first call on characterDeath we count it as car kill
    player:getModData().AKCModData.tk  = player:getModData().AKCModData.tk + 1;--missing update from PZ (car? / fire? / ..?)
    if zombieTableForKillCount and zombieTableForKillCount[charStr] ~= nil then--fire kill
        player:getModData().AKCModData.fk = player:getModData().AKCModData.fk + 1;
    else--car kill (unless it is a weapon kill)
        --and add it to the map
        characterTableForKillCount[charStr] = getTimestampMs();
        --count it as a car kill
        player:getModData().AKCModData.ck = player:getModData().AKCModData.ck + 1;
    end
end
function updateKillCountB41_50_OnZombieDead(character)
    createKillCountModData();
    local charStr = tostring(character);
    local player = getSpecificPlayer(0);
    if characterTableForKillCount and characterTableForKillCount[charStr] ~= nil then
        --second call on zombie dead we were wrong counting it as car kill = remove it from car kill
        characterTableForKillCount = removeFromTable(characterTableForKillCount, charStr);
        --decrease other
        player:getModData().AKCModData.tk  = player:getModData().AKCModData.tk - 1;--correct the error on total kill
        player:getModData().AKCModData.ck  = player:getModData().AKCModData.ck - 1;--correct the error on car kill
    else
        --it is either a fire kill (will be counted by OnCharacterDeath) or a weapon kill (already counted by genuine PZ)
        zombieTableForKillCount[charStr] = getTimestampMs();--it may occure more than once
    end

    local player = getSpecificPlayer(0);
    local previousNumberOfZkilledByWeapon = player:getModData().AKCModData.gk;
    local newNumberOfZkilledByWeapon = player:getZombieKills();
    player:getModData().AKCModData.gk  = newNumberOfZkilledByWeapon;
    local diff = newNumberOfZkilledByWeapon - previousNumberOfZkilledByWeapon;
    if diff > 0 then 
        player:getModData().AKCModData.tk  = player:getModData().AKCModData.tk + diff;--missing update could still be hidden behind a multi-kill ?? maybe ?
    end
end



function isB41_50()
    local strversion = Core:getInstance():getVersionNumber();
    local version4150 = "41.50"
    return string.sub(strversion,1,string.len(version4150))==version4150;
end


function updateKillCountB41_52_OnCharacterDeath(character)
    createKillCountModData();
    local charStr = tostring(character);
    local player = getSpecificPlayer(0);
    --first call on characterDeath we count it as car kill
    player:getModData().AKCModData.tk  = player:getModData().AKCModData.tk + 1;--missing update from PZ (car? / fire? / ..?)
    if zombieTable2ForKillCount and zombieTable2ForKillCount[charStr] ~= nil then--Fire Kill
        player:getModData().AKCModData.fk = player:getModData().AKCModData.fk + 1;
        removeFromTable(zombieTable2ForKillCount, charStr);
        removeFromTable(zombieTableForKillCount, charStr);
    else--car kill (unless it is a weapon kill)
        if zombieTableForKillCount and zombieTableForKillCount[charStr] ~= nil then--Car Kill
            player:getModData().AKCModData.ck = player:getModData().AKCModData.ck + 1;
            removeFromTable(zombieTableForKillCount, charStr);
        else--it is probably a weapon kill, we wil detect it on ZombieDead but let the genuine counter work anyway
            characterTableForKillCount[charStr] = getTimestampMs();
        end
    end
end

function updateKillCountB41_52_OnZombieDead(character)
    createKillCountModData();
    local charStr = tostring(character);
    local player = getSpecificPlayer(0);
    if characterTableForKillCount and characterTableForKillCount[charStr] ~= nil then--Car Kill
        removeFromTable(characterTableForKillCount, charStr);
    else--it is Fire Kill or Car Kill let OnCharacterDeath decide
        if zombieTableForKillCount and zombieTableForKillCount[charStr] ~= nil then--
            zombieTable2ForKillCount[charStr] = getTimestampMs();--Fire Kill
        else
            zombieTableForKillCount[charStr] = getTimestampMs();--Car Kill or Fire Kill
        end
    end
end


if isB41_50() then
    characterTableForKillCount = {};
    zombieTableForKillCount = {};
    Events.OnCharacterDeath.Add(updateKillCountB41_50_OnCharacterDeath);
    Events.OnZombieDead.Add(updateKillCountB41_50_OnZombieDead);
else
    characterTableForKillCount = {};
    zombieTableForKillCount = {};
    zombieTable2ForKillCount = {};
    Events.OnCharacterDeath.Add(updateKillCountB41_52_OnCharacterDeath);
    Events.OnZombieDead.Add(updateKillCountB41_52_OnZombieDead);
end
Events.OnGameStart.Add(createKillCountModData);
Events.OnLoad.Add(createKillCountModData);

--note B41.52 Baseball bat kill (assumed all weapon kill):
--LOG  : General     , 1627142125012> print_OnCharacterDeath zombie.characters.IsoZombie@68e2192e
--LOG  : General     , 1627142125014> print_OnZombieDead zombie.characters.IsoZombie@68e2192e

--note B41.52 Car Kill:
--LOG  : General     , 1627142199795> print_OnZombieDead zombie.characters.IsoZombie@5cb272ba
--LOG  : General     , 1627142199795> print_OnCharacterDeath zombie.characters.IsoZombie@5cb272ba

--note B41.52 Fire Kill:
--LOG  : General     , 1627414823547> print_OnZombieDeadzombie.characters.IsoZombie@2b9acecd 1627414823547
--LOG  : General     , 1627414824927> print_OnZombieDeadzombie.characters.IsoZombie@2b9acecd 1627414824927
--LOG  : General     , 1627414824927> print_OnCharacterDeathzombie.characters.IsoZombie@2b9acecd 1627414824927


--note B41.50 Baseball bat kill (assumed all weapon kill):
--LOG  : General     , 1627143195992> print_OnCharacterDeath zombie.characters.IsoZombie@2e340940
--LOG  : General     , 1627143195993> print_OnZombieDead zombie.characters.IsoZombie@2e340940

--note B41.50 Car Kill:
--LOG  : General     , 1627143315165> print_OnCharacterDeath zombie.characters.IsoZombie@69a62a4b

--note B41.50 Fire Kill:
--LOG  : General     , 1627147335210> print_OnZombieDead zombie.characters.IsoZombie@cf86afc
--LOG  : General     , 1627147335210> print_OnZombieDead zombie.characters.IsoZombie@cf86afc
--LOG  : General     , 1627147335210> print_OnCharacterDeath zombie.characters.IsoZombie@cf86afc
